SystemOrganization addCategory: #'Seaside-Tests-Pharo-Core'!

WAContextTest subclass: #WASqueakFileLibraryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Core'!

!WASqueakFileLibraryTest methodsFor: 'private' stamp: 'jf 10/6/2008 14:23'!
compileUseNewCompiler
	^Preferences
		valueOfFlag: #compileUseNewCompiler
		ifAbsent: [ false ]! !

!WASqueakFileLibraryTest methodsFor: 'private' stamp: 'jf 10/6/2008 14:23'!
hasNewCompiler
	Preferences
		valueOfFlag: #compileUseNewCompiler
		ifAbsent: [ ^false ].
	^true! !

!WASqueakFileLibraryTest methodsFor: 'testing' stamp: 'jf 10/6/2008 14:22'!
testAddAllFilesIn
	| directoryName |
	directoryName := 'XXXUsedBySeasideTests'.
	FileDirectory default createDirectory: directoryName.
	[| directory library |
	directory := FileDirectory default directoryNamed: directoryName.
	[(directory forceNewFileNamed: '.Seaside_Store') in: [ :stream | stream close ].
	(directory forceNewFileNamed: 'foo') in: [ :stream | stream close ].
	SystemChangeNotifier uniqueInstance doSilently: [
		library := WAFileLibrary
			subclass: #XXXTestFileLibrary
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'Uncategorized'.
		[ library addAllFilesIn: directory pathName.
		self assert: library selectors size = 1 ] "reject .Seaside_Store"
			ensure: [ library removeFromSystem ] ] ]
		ensure: [ directory deleteLocalFiles ] ]
		ensure: [ FileDirectory default deleteDirectory: directoryName ]! !

!WASqueakFileLibraryTest methodsFor: 'testing' stamp: 'jf 10/6/2008 17:30'!
testCompileByteArrayLiteralSource
	| library data file source expected |
	self hasNewCompiler ifFalse: [ ^ self ].
	self 
		useCompileUseNewCompiler: true
		during: [
			self assert: self compileUseNewCompiler.
			library := WATestingFiles default.
			data := (1 to: 255) asByteArray.
			file := WAFile new
				contentType: WAMimeType imageJpeg;
				contents: data;
				fileName: 'demo.jpeg';
				yourself.
			library addFile: file.
			
			[ source := WATestingFiles sourceCodeAt: #demoJpeg.
			expected := 'demoJpeg
	^ #[1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255]'.
			self assert: source seasideString = expected ]
				ensure: [ library removeFile: file fileName ] ]! !

!WASqueakFileLibraryTest methodsFor: 'testing' stamp: 'pmm 2/20/2009 17:38'!
testCompileByteArrayWithCacheSource
	| library data file source expected |
	self 
		useCompileUseNewCompiler: false
		during: [
			self deny: self compileUseNewCompiler.
			library := WATestingFiles default.
			data := (1 to: 255) asByteArray.
			file := WAFile new
				contentType: WAMimeType imageJpeg;
				contents: data;
				fileName: 'demo.jpeg';
				yourself.
			library addFile: file.
			
			[ source := WATestingFiles sourceCodeAt: #demoJpeg.
			expected := 'demoJpeg
	^ #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255) asByteArray'.
			self assert: source seasideString = expected ]
				ensure: [ library removeFile: file fileName ] ]! !

!WASqueakFileLibraryTest methodsFor: 'private' stamp: 'jf 10/6/2008 14:23'!
useCompileUseNewCompiler: aBoolean during: aBlock
	| oldValue |
	oldValue := self compileUseNewCompiler.
	[ Preferences setPreference: #compileUseNewCompiler toValue: aBoolean.
	aBlock value ]
		ensure: [
			self hasNewCompiler ifTrue: [
				Preferences setPreference: #compileUseNewCompiler toValue: oldValue ] ]! !

!WAPackage class methodsFor: '*seaside-tests-pharo-core' stamp: 'lr 8/30/2009 17:36'!
seasideTestsSqueakCore
	^ self new
		name: 'Seaside-Tests-Pharo-Core';
		addDependency: 'Seaside-Pharo-Core';
		addDependency: 'Seaside-Tests-Core';
		yourself! !

WAEncoderTest subclass: #WAEncoderSqueakTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Core'!

!WAEncoderSqueakTest methodsFor: 'configuration' stamp: 'pmm 6/7/2009 13:51'!
createCodec
	^ WACodec forEncoding: 'utf-8'! !

!WAEncoderSqueakTest methodsFor: 'private' stamp: 'pmm 4/19/2009 12:00'!
stripLeadingCharFrom: aString
	"strips the leadingChar from every character in the given string"
	^String streamContents: [ :stream |
		aString do: [ :each |
			stream nextPut: (Character leadingChar: 0 code: each seasideInteger) ] ]! !

!WAEncoderSqueakTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:51'!
testEncodedLatin1Url
	self
		assert: (String with: (Character codePoint: 233) with: (Character codePoint: 228))
		encoder: WAUrlEncoder
		gives: '%C3%A9%C3%A4'! !

!WAEncoderSqueakTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:51'!
testEncodedSupplementaryMultilingualPlane
	"The Supplementary Multilingual Plane (SMP: Plane 1, U+010000 - U+01FFFF)
	http://www.unicode.org/charts/PDF/U10140.pdf
	Ancient Greek Zero Sign"
	| zero |
	zero := (Character codePoint: 65930) seasideString.
	self 
		assert: zero
		encoder: WAHtmlEncoder
		gives: zero! !

!WAEncoderSqueakTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:51'!
testEncodedSupplementaryMultilingualPlaneUrl
	"The Supplementary Multilingual Plane (SMP: Plane 1, U+010000 - U+01FFFF)
	http://www.unicode.org/charts/PDF/U10140.pdf
	Ancient Greek Zero Sign"
	| zero |
	zero := (Character codePoint: 65930) seasideString.
	self 
		assert: zero
		encoder: WAUrlEncoder
		gives: '%F0%90%86%8A'! !

!WAEncoderSqueakTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:51'!
testEncodedUnicode
	"this makes sure the encoder doesn't fall on the nose with unicode"
	| hiraA hiraO hiraAO ea |
	ea := String 
		with: (Character codePoint: 233)
		with: (Character codePoint: 228).
	self 
		assert: ea
		encoder: WAHtmlEncoder
		gives: ea.
	hiraA := (Character codePoint: 12354) seasideString.	"HIRAGANA LETTER A"
	hiraO := (Character codePoint: 12362) seasideString.	"HIRAGANA LETTER O"
	hiraAO := hiraA , hiraO.
	self 
		assert: hiraA
		encoder: WAHtmlEncoder
		gives: hiraA.
	self 
		assert: hiraO
		encoder: WAHtmlEncoder
		gives: hiraO.
	self 
		assert: hiraAO
		encoder: WAHtmlEncoder
		gives: hiraAO! !

!WAEncoderSqueakTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:50'!
testEncodedUnicodeUrl
	"this makes sure the encoder doesn't fall on the nose with unicode"
	| hiraA hiraO hiraAO ea |
	ea := String 
		with: (Character codePoint: 233)
		with: (Character codePoint: 228).
	self 
		assert: ea
		encoder: WAHtmlEncoder
		gives: ea.
	hiraA := (Character codePoint: 12354) seasideString.	"HIRAGANA LETTER A"
	hiraO := (Character codePoint: 12362) seasideString.	"HIRAGANA LETTER O"
	hiraAO := hiraA , hiraO.
	self 
		assert: hiraA
		encoder: WAUrlEncoder
		gives: '%E3%81%82'.
	self 
		assert: hiraO
		encoder: WAUrlEncoder
		gives: '%E3%81%8A'.
	self 
		assert: hiraAO
		encoder: WAUrlEncoder
		gives: '%E3%81%82' , '%E3%81%8A'! !

!WAEncoderSqueakTest methodsFor: 'testing' stamp: 'pmm 4/19/2009 12:00'!
testLanguageTag
	"this makes sure the encoder doesn't fall on the nose with unicode"
	"Make Japanese String from unicode. see http://www.unicode.org/charts/PDF/U3040.pdf"
	| leading hiraA hiraO hiraAO |
	leading := (Smalltalk classNamed: #JapaneseEnvironment) leadingChar.
	hiraA := (Character 
		leadingChar: leading
		code: 12354) seasideString.	"HIRAGANA LETTER A"
	hiraO := (Character 
		leadingChar: leading
		code: 12362) seasideString.	"HIRAGANA LETTER O"
	hiraAO := hiraA , hiraO.
	self 
		assert: hiraA
		encoder: WAHtmlEncoder
		gives: (self stripLeadingCharFrom: hiraA).
	self 
		assert: hiraO
		encoder: WAHtmlEncoder
		gives: (self stripLeadingCharFrom: hiraO).
	self 
		assert: hiraAO
		encoder: WAHtmlEncoder
		gives: (self stripLeadingCharFrom: hiraAO)! !

WAEncoderTest subclass: #WAGenericCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Core'!

!WAGenericCodecTest methodsFor: 'private' stamp: 'pmm 7/17/2009 21:28'!
asString: aCollectionOfIntegers
	^String streamContents: [ :stream |
		aCollectionOfIntegers do: [ :each |
			stream nextPut: (Character codePoint: each) ] ]! !

!WAGenericCodecTest methodsFor: 'private' stamp: 'pmm 7/17/2009 21:27'!
latin1String
	^ self asString: #(220 98 232 114 115 116 114 238 241 103 233)! !

!WAGenericCodecTest methodsFor: 'private' stamp: 'pmm 7/17/2009 21:29'!
macromanString
	^ self asString: #(134 98 143 114 115 116 114 148 150 103 142)! !

!WAGenericCodecTest methodsFor: 'testing' stamp: 'pmm 7/17/2009 21:34'!
testGenericCodecAll
	TextConverter allEncodingNames do: [ :name |
		(#('utf-8') includes: name) ifFalse: [
			| codec |
			codec := WACodec forEncoding: name.
			self assert: codec name = name.
			self assert: (codec isKindOf: WAGenericCodec) ] ]! !

!WAGenericCodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:44'!
testGenericCodecMacRoman
	| codec |
	codec := WACodec forEncoding: 'mac-roman'.
	
	self assert: (codec isKindOf: WAGenericCodec).
	self assert: codec name = 'mac-roman'.
	self assert: codec url name = 'utf-8'.
	self assert: (codec url isKindOf: WAUtf8Codec).
	
	self assert: (codec encode: self latin1String) = self macromanString.
	self assert: (codec url encode: self latin1String) = self utf8String.
	self assert: (codec decode: self macromanString) = self latin1String.
	self assert: (codec url decode: self utf8String) = self latin1String! !

!WAGenericCodecTest methodsFor: 'testing' stamp: 'pmm 7/17/2009 21:31'!
testGenericCodecUtf16be
	| codec bom |
	codec := WACodec forEncoding: 'utf-16'.
	self assert: (codec isKindOf: WAGenericCodec).
	bom := #(254 255) asByteArray asString.
	
	self assert: codec name = 'utf-16'.
	self assert: codec url name = 'utf-8'.
	self assert: (codec url isKindOf: WAUtf8Codec).
	
	self assert: (codec encode: self latin1String) = self utf16beString.
	self assert: (codec url encode: self latin1String) = self utf8String.
	self assert: (codec decode: self utf16beString) = self latin1String.
	self assert: (codec decode: bom, self utf16beString) = self latin1String.
	self assert: (codec url decode: self utf8String) = self latin1String! !

!WAGenericCodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:46'!
testGenericCodecUtf16le
	| codec bom |
	codec := WACodec forEncoding: 'utf-16'.
	self assert: (codec isKindOf: WAGenericCodec).
	bom := #(255 254) asByteArray asString.
	
	self assert: codec name = 'utf-16'.
	self assert: codec url name = 'utf-8'.
	self assert: (codec url isKindOf: WAUtf8Codec).
	
	self assert: (codec encode: self latin1String) = self utf16beString.
	self assert: (codec url encode: self latin1String) = self utf8String.
	self assert: (codec decode: bom, self utf16leString) = self latin1String.
	self assert: (codec url decode: self utf8String) = self latin1String! !

!WAGenericCodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:51'!
testInstantiateUtf8
	self should: [ WAGenericCodec forEncoding: 'utf-8' ] raise: WAUnsupportedEncodingError! !

!WAGenericCodecTest methodsFor: 'testing' stamp: 'pmm 7/4/2009 23:47'!
testSqueakCodecLatin1
	"tests the codec for 'lating-1' and #converter"
	#('iso-8859-1' 'ISO-8859-1' 'latin-1') do: [ :each |
		| codec |
		codec := WACodec forEncoding: each.
		
		self assert: codec converter notNil.
		self assert: codec name = each.
		self assert: codec url converter notNil.
		self assert: codec url name = each.
		
		self assert: (codec encode: self latin1String) = self latin1String.
		self assert: (codec url encode: self latin1String) = self latin1String.
		self assert: (codec decode: self latin1String) = self latin1String.
		self assert: (codec url decode: self latin1String) = self latin1String ]! !

!WAGenericCodecTest methodsFor: 'private' stamp: 'pmm 7/17/2009 21:32'!
utf16beString
	^ self asString: #(0 220 0 98 0 232 0 114 0 115 0 116 0 114 0 238 0 241 0 103 0 233)! !

!WAGenericCodecTest methodsFor: 'private' stamp: 'pmm 7/17/2009 21:32'!
utf16leString
	^ self asString: #(220 0 98 0 232 0 114 0 115 0 116 0 114 0 238 0 241 0 103 0 233 0)! !

!WAGenericCodecTest methodsFor: 'private' stamp: 'pmm 7/17/2009 21:30'!
utf8String
	^ self asString: #(195 156 98 195 168 114 115 116 114 195 174 195 177 103 195 169)! !

!WAUtf8CodecTest methodsFor: '*seaside-tests-pharo-core' stamp: 'pmm 7/4/2009 23:37'!
expectedFailures
	^#(testCodecUtf8ShortestForm)! !

TestCase subclass: #WAFormTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Core'!

!WAFormTestCase class methodsFor: 'testing' stamp: 'jf 10/6/2008 15:28'!
isAbstract
	^ self name = #WAFormTestCase! !

!WAFormTestCase methodsFor: 'private' stamp: 'jf 10/6/2008 15:21'!
formClassExists
	^ Smalltalk hasClassNamed: #Form! !

!WAFormTestCase methodsFor: 'private' stamp: 'jf 10/6/2008 15:17'!
sampleForm
	^(Smalltalk classNamed: #Form)
		extent: 16@16
		depth: 1
		fromArray: #( 0 0 0 50331648 25165824 12582912 281018368 415236096 264241152 132120576 7340032 3670016 1572864 0 0 0)
		offset: 0@0! !

WAFormTestCase subclass: #WASqueakDocumentHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Core'!

!WASqueakDocumentHandlerTest methodsFor: 'testing' stamp: 'jf 7/31/2009 09:38'!
testForm
	| handler context |
	self formClassExists ifFalse: [ ^ self ].
	
	handler := WADocumentHandler
		document: self sampleForm
		mimeType: self sampleForm defaultMimeType
		fileName: nil.
	
	context := WARequestContext request: WARequest new response: WABufferedResponse new.
	[ handler handle: context ] on: WAResponseNotification do: [ :n | ].
	
	self assert: context response notNil! !

WAFormTestCase subclass: #WASqueakMimeDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Core'!

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:44'!
testAsMIMEDocumentForm
	| form document |
	self formClassExists ifFalse: [ ^ self ].
	
	form := self sampleForm.
	document := form seasideMimeDocument.
	self assert: document contentType = WAMimeType imageGif.
	self assert: (document content isKindOf: ByteArray)! !

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:44'!
testAsMIMEDocumentFormColon
	| form document |
	self formClassExists ifFalse: [ ^ self ].
	
	form := self sampleForm.
	document := form seasideMimeDocumentType: WAMimeType imageJpeg.
	self assert: document contentType = WAMimeType imageJpeg.
	self assert: (document content isKindOf: ByteArray)! !

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:44'!
testAsMIMEDocumentFormColonString
	| form document |
	self formClassExists ifFalse: [ ^ self ].
	
	form := self sampleForm.
	document := form seasideMimeDocumentType: WAMimeType imageJpeg seasideString.
	self assert: document contentType = WAMimeType imageJpeg.
	self assert: (document content isKindOf: ByteArray)! !

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'jf 10/6/2008 15:24'!
testAsMIMEDocumentFormUnknown
	| form |
	self formClassExists ifFalse: [ ^ self ].
	
	form := self sampleForm.
	self should: [ form seasideMimeDocumentType: 'foo/bar' ] raise: Error.
	self should: [ form seasideMimeDocumentType: 'foo/bar' seasideMimeType ] raise: Error.
	self should: [ form seasideMimeDocumentType: 'image/zork' ] raise: Error.
	self should: [ form seasideMimeDocumentType: 'image/zork' seasideMimeType ] raise: Error.! !

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'pmm 11/5/2008 15:40'!
testAsMIMEDocumentMorph
	| morph document |
	morph := EllipseMorph new
		color: Color red;
		borderWidth: 1;
		borderColor: Color black;
		extent: 12;
		yourself.
	document := morph seasideMimeDocument.
	self assert: document contentType = WAMimeType imageGif.
	self assert: (document content isKindOf: ByteArray)! !

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'pmm 11/5/2008 15:40'!
testAsMIMEDocumentMorphColol
	| morph document |
	morph := EllipseMorph new
		color: Color red;
		borderWidth: 1;
		borderColor: Color black;
		extent: 12;
		yourself.
	document := morph seasideMimeDocumentType: WAMimeType imageJpeg.
	self assert: document contentType = WAMimeType imageJpeg.
	self assert: (document content isKindOf: ByteArray)! !

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:45'!
testAsMIMEDocumentStream
	| document |
	document := 'dolphin' readStream seasideMimeDocument.
	self assert: document contentType = WAMimeType textPlain.
	self assert: document content = 'dolphin'! !

!WASqueakMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:45'!
testAsMIMEDocumentStreamColon
	| document |
	document := 'monkey' readStream seasideMimeDocument.
	document mimeType: 'text/html'.
	self assert: document contentType = WAMimeType textHtml.
	self assert: document content = 'monkey'! !
